﻿Public Class HarmonicsExtractor

    Friend Harmonics() As Single
    Friend HarmonicDistortion As Single

    Private Const kdb As Double = 8.685889638
    Private Const kVolt As Single = 3.3

    Friend Sub ExtractHarmonics(ByVal FhtBuffer() As Single, _
                                ByVal SampleFreq As Int32, _
                                ByVal Frequency As Single, _
                                ByVal PrecisionPercentual As Single)

        If FhtBuffer Is Nothing Then Return
        Dim nn As Int32 = FhtBuffer.Length * 2
        Dim kf As Single = CSng(nn / SampleFreq)
        Dim nHarmonics As Int32 = CInt(Math.Floor(SpecMaxFreq / Frequency + 1))
        If nHarmonics > 100 Then nHarmonics = 100
        ReDim Harmonics(nHarmonics - 1)
        ' ------------------------------------------------------------------ Harmonics by max value
        For HarmonicIndex As Int32 = 0 To nHarmonics - 1
            Dim hfreq As Single = Frequency * HarmonicIndex
            Dim minFreq As Single = hfreq - hfreq * PrecisionPercentual / 100
            Dim maxFreq As Single = hfreq + hfreq * PrecisionPercentual / 100
            Dim minIndex As Int32 = CInt(minFreq * kf)
            Dim maxIndex As Int32 = CInt(maxFreq * kf)
            If maxIndex > nn \ 2 - 1 Then maxIndex = nn \ 2 - 1
            Dim v As Single
            For i As Int32 = minIndex To maxIndex
                v = FhtBuffer(i) * 2
                If v > Harmonics(HarmonicIndex) Then Harmonics(HarmonicIndex) = v
            Next
        Next
        ' ------------------------------------------------------------------ THD by squared sum
        If nHarmonics > 1 Then
            If Harmonics(1) > 0 Then
                Dim sum As Double = 0
                For i As Int32 = 2 To Harmonics.Length - 1
                    sum += (Harmonics(i)) ^ 2
                Next
                HarmonicDistortion = CSng(100 * Math.Sqrt(sum) / Harmonics(1))
            End If
        End If
    End Sub

End Class
