﻿Module Program

    '  Time     Samples    Db     Precision
    ' ------------------------------------
    '  4 min.   131072     46     0.5%
    '  2 min.    65536     43     0.7%
    '  1 min     32768     40     1.0%
    '  30 sec    16384     37     1.5%
    '  15 sec     8192     34     2.0%
    '   8 sec     4096     31     3.0%
    '   4 sec     2048     28     4.0%
    '   2 sec     1024     25     6.0%
    '   1 sec      512     22     8.0%
    '
    ' approximated values for a 50 Hz wave analisys
    '
    ' for 25 Hz add  6 dB
    ' for 12 Hz add 12 dB
    ' for  6 Hz add 18 dB
    ' for  3 Hz add 24 dB

    Friend FHT_Samples As Int32 = 512 * 64 ' (64 seconds) 

    Friend FIFO_Lenght As Int32 = 512 * 256 ' (256 seconds max)
    Friend Const SamplesPerSec As Int32 = 44100

    Friend DisplayScope1 As DisplayScope = New DisplayScope
    Friend DisplaySpectrum1 As DisplaySpectrum = New DisplaySpectrum
    Friend DisplayBands1 As DisplayBands = New DisplayBands

    Friend BandsExtractor1 As BandsExtractor = New BandsExtractor
    Friend BandsExtractor2 As BandsExtractor = New BandsExtractor

    Friend HarmonicsExtractor1 As HarmonicsExtractor = New HarmonicsExtractor

    Friend Fifo1 As FIFO = New FIFO(FIFO_Lenght)
    Friend Fht1 As FHT = New FHT
    Private m_InputBuffer() As Single

    Friend Enum ChannelsType
        AddLR
        SubtractLR
        Left
        Right
    End Enum
    Friend Channels As ChannelsType
    Friend InputTrimmer As Single

    Friend HarmonicsOutputSlot As Int32 = -1
    Friend ThdOutputSlot As Int32 = -1
    Friend HarmonicsBaseFreq As Single
    Friend HarmonicsDeltaFreq As Single

    Friend RemoveDC As Boolean

    Friend SpecMinFreq As Single
    Friend SpecMaxFreq As Single
    Friend SpecMinDb As Single
    Friend SpecMaxDb As Single
    Friend SpecSpeed As Single
    Friend SpecLogX As Boolean
    Friend SpecLogY As Boolean

    Friend BandsCount As Int32
    Friend BandsOutputSlot As Int32 = -1


    Friend Sub FHT_Initialize()
        ReDim m_InputBuffer(FHT_Samples - 1)
    End Sub

    Friend Sub FHT_Execute(ByVal fmin As Single, _
                           ByVal fmax As Single, _
                           ByVal dbmin As Single, _
                           ByVal dbmax As Single, _
                           ByVal xlog As Boolean, _
                           ByVal ylog As Boolean, _
                           ByVal speed As Single, _
                           ByVal windowtype As FHT.WindowTypes)
        '
        Fifo1.SetReadIndex(Fifo1.GetWriteIndex - m_InputBuffer.Length)
        Fifo1.GetArray(m_InputBuffer)
        Fht1.ExecuteFHT(m_InputBuffer, windowtype)
    End Sub

End Module
